## rocm-smi-lib 5.2.3

=== debian/changelog ===
rocm-smi-lib (5.2.3-2) unstable; urgency=medium

  * d/control: use shorthand "ROCm" in packages descriptions instead of the
    long form.

 -- Étienne Mollier <emollier@debian.org>  Fri, 02 Dec 2022 23:10:31 +0100

rocm-smi-lib (5.2.3-1) unstable; urgency=medium

  * Migrate ROCm 5.2.3 to unstable.
  * d/*.symbols renamed d/*.symbols.amd64: work around ftbfs on non-amd64.

 -- Étienne Mollier <emollier@debian.org>  Mon, 17 Oct 2022 22:05:33 +0200

rocm-smi-lib (5.2.3-1~0exp0) experimental; urgency=medium

  * New upstream version

 -- Étienne Mollier <emollier@debian.org>  Mon, 05 Sep 2022 21:00:19 +0200
