=== debian/control ===
--- 
+++ 
@@ -34,9 +34,9 @@
          ${shlibs:Depends}
 Description: ROCm System Management Interface (ROCm SMI) library
  The ROCm System Management Interface Library, or ROCm SMI library,
- is part of the Radeon Open Compute software stack. It is a
- C library for Linux that provides a user space interface for
- applications to monitor and control GPU applications.
+ is part of the ROCm software stack. It is a C library for Linux
+ that provides a user space interface for applications to monitor
+ and control GPU applications.
 
 Package: librocm-smi-dev
 Architecture: any
@@ -44,9 +44,9 @@
 Depends: ${misc:Depends},
          librocm-smi64-1 (= ${binary:Version})
 Description: ROCm System Management Interface (ROCm SMI) library headers
- ROCm SMI is part of the Radeon Open Compute software stack. It is a
- C library for Linux that provides a user-space interface for
- applications to monitor and control GPU applications.
+ ROCm SMI is part of the ROCm software stack. It is a C library for Linux
+ that provides a user-space interface for applications to monitor and
+ control GPU applications.
  .
  This package contains the development headers.
